#include <ri.h>
#include <stdio.h>

#include "hcountor.h"

SurfOR(points, npoints) 
Point2D points[]; 
int npoints; 
{ 
    int pt; 
    RtPoint point1, point2; 
    RtFloat *pp1, *pp2, *tmp; 
        pp1 = point1; 
        pp2 = point2; 

    pp1[0] = points[0].y; 
    pp1[1] = 0; 
    pp1[2] = points[0].x; 
    for (pt = 1; pt < npoints; pt++) { 
        pp2[0] = points[pt].y; 
        pp2[1] = 0; 
        pp2[2] = points[pt].x; 
        RiHyperboloid(pp1, pp2, 360.0, RI_NULL); 
        tmp = pp1; pp1 = pp2; pp2 = tmp;         /* Swap pointers */ 
    } 
} 

SolidSurfOR(points, npoints)
Point2D points[];
int npoints;
{
    RiSolidBegin(RI_PRIMITIVE);

		SurfOR(points, npoints);         /* ... from Chapter 4 */  

        if (points[0].y != 0.0)          /* Seal the object at the ends */
            RiDisk(points[0].x, points[0].y, 360.0, RI_NULL);
        
        if (points[npoints-1].y != 0.0) 
            RiDisk(points[npoints-1].x,
                points[npoints-1].y, 360.0, RI_NULL);

    RiSolidEnd();
}

void main()
{
	RtColor color = {.9,.9,.5};

	RiBegin( "rgl" );
		
		RiProjection( RI_PERSPECTIVE, RI_NULL );
		RiLightSource( "distantlight", RI_NULL );
		RiTranslate( 0.0, -0.7, 1.2 );

		RiWorldBegin();
			RiRotate( 90.0, -1.0, 0.0, 0.0 );
			RiSurface( "constant", RI_NULL );
			
			RiColor(color);
    		SolidSurfOR( points, NPOINTS );
		RiWorldEnd();
	RiEnd();
}

